#include <iostream>
#include <iomanip>
using namespace std;

#define LINHAS    3
#define COLUNAS   3

class Matrix {
  int **mat;
  int linhas, colunas;

public:
  Matrix();
  Matrix(int lins, int cols);
  Matrix(int **newmat, int lins, int cols);
  void entrada();
  void saida();
  int getElement(int i, int k) const;

  // Funcao eh amiga, mas nao eh parte da classe.
  friend const Matrix operator +(const Matrix& mat1, const Matrix& mat2);
};


Matrix::Matrix()
{
  int i, k;

  linhas = LINHAS;
  colunas = COLUNAS;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = 0;
  }
}

Matrix::Matrix(int **newmat, int lins, int cols)
{
  int i, k;

  linhas = lins;
  colunas = cols;

  mat = new int* [linhas];

  for (i=0; i < linhas; i++) {
    mat[i] = new int(colunas);
    for (k=0; k < colunas; k++)
      mat[i][k] = newmat[i][k];
  }
}

void Matrix::entrada ()
{
  int i, k;
  for (i=0; i < linhas; i++) {
    for (k=0; k < colunas; k++) {
      cout << "\t elemento (" << i << "," << k << "): ";
      cin >> mat[i][k];
    }
  }
}

void Matrix::saida ()
{
  int i, k;
  for (i=0; i < linhas; i++) {
    //    cout.setf(ios::showpoint|ios::fixed);
    //    cout.precision(2);
    for (k=0; k < colunas; k++)
      cout << setw(5) << mat[i][k] << "\t";
    cout << endl;
  }
}

int Matrix::getElement(int i, int k) const
{
  return (mat[i][k]);
}

// ======= FIM DOS METODOS DA CLASSE =========


// Funcao eh amiga, mas nao eh parte da classe.
const Matrix operator+ (const Matrix& mat_1, const Matrix& mat_2)
{
  int i, k;
  int **soma = new int* [mat_1.linhas];

  for (i=0; i < mat_1.linhas; i++)
    soma[i] = new int [mat_1.colunas];

  for (i=0; i < mat_1.linhas; i++)
    for (k=0; k < mat_1.colunas; k++)
      soma[i][k] = mat_1.mat[i][k] + mat_2.mat[i][k];
  
  return (Matrix(soma, mat_1.linhas, mat_1.colunas));
}


main () 
{
  Matrix matriz(6,6), soma(6,6), result(6,6);

  cout << "Forneca os valores da Matriz 1:\n";
  matriz.entrada();
  cout << "\n\n";
  cout << "Forneca os valores da Matriz 2:\n";
  soma.entrada();

  result = soma + matriz;
  cout << "\n\nSoma das matrizes = \n";
  result.saida();
}

